<?php
/**
* Google site map
* @version 2.0.2
* @package gsg.org
* @copyright (C) 2004 by rg66
* @license Released under the terms of the GNU General Public License
**/

/** ensure this file is being included by a parent file */
defined('_VALID_MOS') or die('Direct Access to this location is not allowed.');

//ensure that the user is still logged in
global $my;

if ($my->id < 0)
	: mosRedirect('index.php', _NOT_AUTH);
endif;

require_once ($mainframe->getPath('admin_html'));
require_once ($mainframe->getPath('class'));

$parent = mosGetParam($_POST, 'parent', '');
$task = mosGetParam($_REQUEST, 'task', array (0));
$msg = mosGetParam($_REQUEST, 'msg', '');
$fontcolor = mosGetParam($_REQUEST, 'fontcolor', '009900');
$cid = mosGetParam($_POST, 'cid', array (0));
$xml_rows = mosGetParam($_POST, 'xml_rows', array (0));
$xml_check = mosGetParam($_POST, 'check', array (0));
$xml_title = mosGetParam($_POST, 'title', array (0));
$xml_url = mosGetParam($_POST, 'url', array (0));
$xml_date = mosGetParam($_POST, 'date', array (0));
$xml_freq = mosGetParam($_POST, 'freq', array (0));
$xml_priority = mosGetParam($_POST, 'priority', array (0));

if (!is_array($cid)) {
	$cid = array (0);
}

// Get the right language if it exists
if (file_exists($mosConfig_absolute_path.'/administrator/components/com_gsg/language/'.$mosConfig_lang.'.php')) {
	include ($mosConfig_absolute_path.'/administrator/components/com_gsg/language/'.$mosConfig_lang.'.php');
} else {
	include ($mosConfig_absolute_path.'/administrator/components/com_gsg/language/english.php');
}

require_once ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.config.php");
//include_once( $mosConfig_absolute_path.'/globals.php' );
require_once ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.class.php");

switch ($task) {
	case "cancel" :
		cancel($option);
		break;

	case "config" :
		showconfig($option, $msg, $fontcolor);
		break;

	case "saveconfig" :
		saveconfig($option, 1);
		break;

	case "saveexit" :
		saveconfig($option, 0);
		break;

	case "about" :
		showabout($option);
		break;

	case "show" :
		show($option, $gsg_url_changefreq, $gsg_url_priority);
		break;

	case "geturl" :
		geturl($option);
		break;

	case "xml" :
		xml($option, $xml_rows, $xml_check, $xml_title, $xml_url, $xml_date, $xml_freq, $xml_priority);
		break;

	case "update" :
		update($option);
		break;

	case "view" :
		view($option);
		break;

	case "plugin" :
		plugin($option);
		break;

	case "cleanplugins" :
		cleanFiles($option);
		break;

	case "active" :
		active($cid, 1, $option);
		break;
	case "notactive" :
		active($cid, 0, $option);
		break;

	case "uploadfile" :
		upload($option);
		break;

	case "deletefile" :
		delete($cid, $option);
		break;

	default :
		showmenu($option);
		break;
}

/**
* Compiles a list of crm dropdown items
*/
function show($option, $gsg_url_changefreq, $gsg_url_priority) {
	global $database, $mainframe, $mosConfig_list_limit, $mosConfig_live_site, $mosConfig_absolute_path, $gsg_menus;
	require_once ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.config.php");

	$results = gsg :: getPluginData();

	HTML_gsg :: show($option, $results, $mosConfig_live_site, $gsg_url_changefreq, $gsg_url_priority);
}

/**
* Get the urls and then call up the function xml
*/
function geturl($option) {
	gsg :: geturl($option, false);
}

/**
* Cancels an edit operation
* @param option	options for the operation
*/
function cancel($option) {
	mosRedirect('index2.php?option=com_gsg&task=showmenu');
}

/**
* Shows the About section
*
*/
function showabout() {
	global $mosConfig_live_site;
	HTML_gsg :: about($mosConfig_live_site);
}

/**
* Shows the Main Menu
*
*/
function showmenu($option) {
	global $mosConfig_live_site, $mosConfig_absolute_path;
	require ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.config.php");
	$localpath = $mosConfig_absolute_path."/administrator/components/com_gsg/config/gsg_version.xml";
	$localversion = gsg :: getXMLElementData("version", $localpath);

	if ($gsg_displayedit) {
		$task = "show";
	} else {
		$task = "geturl";
	}

	HTML_gsg :: showmenu($option, $localversion, $task);
}

/**
* Shows the config
*
*/
function showconfig($option, $msg, $fontcolor) {
	global $database;
	$query = "SELECT title,params"."\n FROM #__modules"."\n WHERE module='mod_mainmenu' AND published = '1'";

	$database->setQuery($query);
	$rows = $database->loadObjectList();

	HTML_gsg :: config($option, $rows, $msg, $fontcolor);
}

/**
* Makes the XML File
*
*/
function xml($option, $xml_rows, $xml_check, $xml_title, $xml_url, $xml_date, $xml_freq, $xml_priority) {

	gsg :: xml($option, $xml_rows, $xml_check, $xml_title, $xml_url, $xml_date, $xml_freq, $xml_priority, false);

}

/**
* Checks for if there is an update
*/

function update($option) {
	global $mosConfig_absolute_path;
	$trunkpath = "http://www.bgl.or.at/administrator/components/com_gsg/config/gsg_version.xml";
	//$trunkpath = "http://localhost/BGL/administrator/components/com_gsg/gsg_version.xml";
	$localpath = $mosConfig_absolute_path."/administrator/components/com_gsg/config/gsg_version.xml";

	$trunkversion = gsg :: getXMLElementData("version", $trunkpath);
	$localversion = gsg :: getXMLElementData("version", $localpath);

	if ($trunkversion > $localversion) {
		$msg_update = "<a href=\"http://developer.joomla.org/integration/viewcvs/viewcvs.cgi/tags/?root=gsg2&amp;system=exsy1002\">"._gsg_update_available."</a>";
	} else {
		$msg_update = _gsg_update_not_available;
	}

	HTML_gsg :: update($option, $trunkversion, $localversion, $msg_update);
}

/**
* View the XML File
*/
function view($option) {
	global $mosConfig_absolute_path;
	require ($mosConfig_absolute_path."/administrator/components/com_gsg/gsg.config.php");
	require_once ($mosConfig_absolute_path."/includes/domit/xml_domit_include.php");

	if (strlen($gsg_location)) {
		$slash = "/";
	}
	
	$xmlfile = $mosConfig_absolute_path."/".$gsg_location.$slash.$gsg_filename.".xml";

	$gsgCollection = & new DOMIT_Document();
	$success = $gsgCollection->loadXML($xmlfile);

	if ($success) {
		$gsgDocumentElement = & $gsgCollection->documentElement;
		$xmlcontent = $gsgDocumentElement->toNormalizedString(true);
	} else {
		$xmlcontent = _gsg_view_error;
	}

	HTML_gsg :: view($option, $xmlcontent);
}

function plugin($option) {
	global $database;
	$query = "SELECT id, classname, enabled, description"."\n FROM #__gsgconfig";

	$database->setQuery($query);
	$rows = $database->loadObjectList();

	HTML_gsg :: plugin($option, $rows);
}

function active($cid = null, $active = 1, $option) {
	global $database, $mosConfig_absolute_path;

	if (count($cid) < 1) {
		$action = $active ? _gsg_active_make : _gsg_active_notmake;
		echo "<script>alert('"._gsg_active_select.$action."'); window.history.go(-1);</script>\n";
		exit;
	}

	mosCache :: cleanCache('com_gsg');

	$cids = implode(',', $cid);
	$query = "UPDATE #__gsgconfig SET enabled=$active"."\n WHERE id IN ($cids)";

	$database->setQuery($query);
	if (!$database->query()) {
		echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
		exit;
	}

	if (count($cid) == 1) {
		$row = new gsgconfig2($database);
		$row->checkin($cid[0]);
	}

	mosRedirect('index2.php?task=plugin&option='.$option);
}

function upload($option) {
	global $mosConfig_absolute_path, $database;

	$msg = "";
	$uploaded_file = $_FILES['userfile']['tmp_name'];
	$filename = gsg :: checkName($_FILES['userfile']['name']);
	$newfile = $mosConfig_absolute_path."/administrator/components/com_gsg/plugins/".basename($filename);
	if (!(is_dir($mosConfig_absolute_path."/administrator/components/com_gsg/plugins"))) {
		$msg .= _gsg_upload_pathnotfound;
	}

	if (!is_file($_FILES['userfile']['tmp_name'])) {
		$msg .= _gsg_upload_filenotfound;
	}

	if (is_file($newfile)) {
		$msg .= _gsg_upload_fileexists;
		mosRedirect("index2.php?task=plugin&option=$option", $msg);
		break;
	}

	if (move_uploaded_file($uploaded_file, $newfile)) {
		//file uploaded successful
		$msg .= _gsg_upload_fileuploaded;
		//make entry into database.  Don't change this var name!'
		$filename = explode(".", basename($filename), 2);

		require_once ($mosConfig_absolute_path."/administrator/components/com_gsg/gsgextension.class.php");
		require_once ($newfile);
		//instanciate an instance for description
		$instance = new $filename[0];

		$query = "INSERT IGNORE INTO  #__gsgconfig  VALUES ('', '$filename[0]', '".$instance->getDescription()."', 0 )";

		$database->setQuery($query);
		$database->query();
		if (!$database->query()) {
			echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
			exit;
		}

		//call html section
		mosRedirect("index2.php?task=plugin&option=$option", $msg);
	} else {
		switch ($_FILES['userfile']['error']) {
			case UPLOAD_ERR_INI_SIZE :
				$msg .= _gsg_upload_UPLOAD_ERR_INI_SIZE_1.ini_get("upload_max_filesize")._gsg_upload_UPLOAD_ERR_INI_SIZE_2;
				break;
			case UPLOAD_ERR_FORM_SIZE :
				$msg .= _gsg_upload_UPLOAD_ERR_FORM_SIZE;
				break;
			case UPLOAD_ERR_PARTIAL :
				$msg .= _gsg_upload_UPLOAD_ERR_PARTIAL;
				break;
			case UPLOAD_ERR_NO_FILE :
				$msg .= _gsg_upload_UPLOAD_ERR_NO_FILE;
				break;
			case UPLOAD_ERR_NO_TMP_DIR :
				$msg .= _gsg_upload_UPLOAD_ERR_NO_TMP_DIR;
				break;
			default :
				$msg .= _gsg_upload_ERR_DEFAULT;
		}

		//call the html section
		mosRedirect("index2.php?task=plugin&option=$option", $msg);
	}
}

function delete($cid = null, $option) {
	global $database, $mosConfig_absolute_path;
	$msg = "<ul>";

	$cids = implode(',', $cid);

	//We get the records selected
	$query = "SELECT id, classname, enabled"."\n FROM #__gsgconfig"."\n WHERE id IN ($cids)";

	$database->setQuery($query);
	$rows = $database->loadObjectList();

	$ABSDIR = $mosConfig_absolute_path."/administrator/components/com_gsg";
	$PLUGINDIR = $ABSDIR."/plugins/";

	for ($i = 0, $n = count($rows); $i < $n; $i ++) {
		$row = & $rows[$i];

		$class_title = $row->classname;
		$file_name = $class_title.".class.php";
		$file_path = $PLUGINDIR.$file_name;

		if ($class_title == "gsgdefault") {
			//we do nothing and inform the user that he can not delete gsgdefault
			$msg .= "<li>"._gsg_delete_gsgdefault."</li>";
			$msg .= "</ul>";
			mosRedirect("index2.php?task=plugin&option=$option", $msg);
			break;
		} else {
			//We check to see if the file exists!
			//echo $file_path;
			if (is_file($file_path)) {
				$msg .= "<li>"._gsg_delete_plugin_1.$file_name._gsg_delete_plugin_2."</li>";
				unlink($file_path);
			} else {
				$msg .= "<li>"._gsg_delete_nofile."</li>";
			}

			//We delete the entry in the databse now
			$query = "DELETE FROM  #__gsgconfig  WHERE id =$row->id";

			$database->setQuery($query);
			$database->query();
			if (!$database->query()) {
				echo "<script>alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
				exit;
			}
			$msg .= _gsg_delete_3p_db_1.$class_title._gsg_delete_3p_db_2;
		}
	}
	//open the plugin section again
	$msg .= "</ul>";
	mosRedirect("index2.php?task=plugin&option=$option", $msg);
}

function saveconfig($option, $saveexit) {
	global $database, $mosConfig_absolute_path;
        
	$gsg_msg = "";
	$gsg_error = 0;
	
	$gsg_filename = mosGetParam($_POST, 'gsg_filename', '0');
	$gsg_location = mosGetParam($_POST, 'gsg_location', '0');
	$gsg_old_filename = mosGetParam($_POST, 'gsg_old_filename', '0');
	$gsg_old_location = mosGetParam($_POST, 'gsg_old_location', '0');

	$row = new gsgConfig();
	if (!$row->bind($_POST)) {
		mosRedirect('index2.php', $row->getError());
	}

	$row->gsg_menus = implode(',', $row->gsg_menus);

	$config = "<?php \n";
	$config .= $row->getVarText();
	$config .= '?>';

	$fname = $mosConfig_absolute_path.'/administrator/components/com_gsg/gsg.config.php';

	//we check to see if the path where the file should be stored exists
	//if not we will create the new folder
	$isdir = is_dir($mosConfig_absolute_path."/".$gsg_location);

	if (!$isdir) {
		//mkdir($mosConfig_absolute_path."/".$gsg_location, 0755);
		$gsg_msg  .= _gsg_no_folder.strtoupper($gsg_location)._gsg_no_folder_2;
		$gsg_error++;
	}

	//we check to see if the name has been changed
	$slash = "";
	$slash2 = "";
	if (strlen($gsg_location)) {
		$slash = "/";
	}

	if (strlen($gsg_old_location)) {
		$slash2 = "/";
	}

	if ($gsg_old_filename != $gsg_filename) {
		$oldfile = $mosConfig_absolute_path."/".$gsg_location.$slash2.$gsg_old_filename.".xml";
		$newfile = $mosConfig_absolute_path."/".$gsg_location.$slash.$gsg_filename.".xml";

		if (rename($oldfile, $newfile)) {
			$gsg_msg .= _gsg_xmlfile_renamed;
		} else {
			$gsg_msg .= _gsg_xmlfile_not_renamed;
			$gsg_error++;
			$gsg_filename = " - ".$gsg_old_filename;
		}
	}

	// we check to see if the file needs to be moved
	//if ($gsg_old_location != $gsg_location) {
	//	$oldfile2 = $mosConfig_absolute_path."/".$gsg_old_location.$slash2.$gsg_filename.".xml";
	//	$newfile2 = $mosConfig_absolute_path."/".$gsg_location.$slash.$gsg_filename.".xml";

	//	if (rename($oldfile2, $newfile2)) {
	//		$gsg_msg2 = " - "._gsg_xmlfile_moved;
	//		unlink($oldfile2);
	//		if (!strlen($gsg_old_location)) {
	//			//HAVE TO SEE HOW WE CAN DELETE THE FOLDER AS WELL
	//			//$gsg_msg2 .="folder deleted";
	//		}
	//	} else {
	//		$gsg_msg2 = " - "._gsg_xmlfile_not_moved;
	//		$gsg_location = $gsg_old_location;
	//	}
	//}

	$enable_write = mosGetParam($_POST, 'enable_write', 0);
	$oldperms = fileperms($fname);
	if ($enable_write) {
		@ chmod($fname, $oldperms | 0222);
	}
        
	$msg = $gsg_msg;
	
	if (!$gsg_error){
		if ($fp = fopen($fname, 'w')) {
			fputs($fp, $config, strlen($config));
			fclose($fp);
			if ($enable_write) {
				@ chmod($fname, $oldperms);
			} else {
				if (mosGetParam($_POST, 'disable_write', 0))
					@ chmod($fname, $oldperms & 0777555);
			} // if

			$gsg_msg .= _gsg_configuration_saved;
                        
			if($saveexit){
				mosRedirect("index2.php?option=$option&task=config&msg=$gsg_msg&fontcolor=009900");
			} else {
			       mosRedirect("index2.php?option=$option",$gsg_msg);
			}
			
		} else {
			if ($enable_write) {
				@ chmod($fname, $oldperms);
			}
			mosRedirect("index2.php?option=$option&task=config&msg=$gsg_msg");
		}
	} else {
	mosRedirect("index2.php?option=$option&task=config&msg=$gsg_msg&fontcolor=FF0000");
	}

}

function cleanFiles($option) {
	//clean up the bogus files plugins
	
	$count = gsg :: cleanPlugins();

	//call html section
	mosRedirect("index2.php?task=plugin&option=$option", $count . " files successfully removed ");

}
?>




